BEGIN		pushn det  // Check whether detector is already here


		pushc 1
		rdp  
		rjumpc DIE
OUT_DETECTOR	pushn det  // detector not here, OUT a detector tuple	


		pushc 1 
		out  // atomic w/ respect to the rdp b/c of min # of instructions (fix me)
		rjump REGISTER_RXN
DIE		halt						
RXN_FIRED	pushc 10 // 01010
		putled // turn off green LED
		pushc 12 // 01100
		putled // turn off yellow LED
		pushn det
		
		
		pushc 1
		inp  // remove fire detector tuple
		halt		
REGISTER_RXN	pushn fir


		pushc 1
		pushc RXN_FIRED
		regrxn  // register fire reaction, die when reaction fires					
CHECK_NEIGHBORS	pushn fir


		pushc 1
		rrdpg  // check if any neighbors are on fire
		rjumpc FORM_BARRIER
RANDOM_MOVE	pushc 20  // no neighbors are on fire, random move
		putled  // turn on yellow LED
		pushc 8
		sleep
		pushc 12
		putled  // turn off yellow LED
		pushn det  
		
		
		pushc 1
		inp  // remove the detector tuple				
		randnbr
		wmove  // weak move to random neighbor					
FORM_BARRIER	pushc 18  // opstack is empty now
		putled  // turn on the green LED
		pushc 0 // for each neighbor whose dist <= 2 of fire, wclone to it
		setvar 9 // heap[9] = neighbor counter, init=0
BARRIER_LOOP	getvar 9
		numnbrs
		ceq
		rjumpc BARRIER_DONE
		pushcl BARRIER_RET
		
		
		getvar 9
		getnbr // get the i'th neighbor
		pushcl CHECK_DIST

		
		jumps // check the distance of the i'th nbr
BARRIER_DONE	rand  
		pushc 15 // 15=1111b
		land     
		pushc 5
		add
		sleep // sleep between 5/8-20/8 seconds
		pushc CHECK_NEIGHBORS
		jumps
BARRIER_RET	rjumpc BARRIER_FIRE
		rjump BARRIER_NXT2  // not close to fire, skip
BARRIER_NXT	pop
		pop
BARRIER_NXT2	getvar 9
		inc
		setvar 9  // proceed to next neighbor
		pushc BARRIER_LOOP
		jumps  // proceed to next neighbor
BARRIER_FIRE	pushn fir  // check if neighbor is on fire

		
		pushc 1
		getvar 9
		getnbr  
		rrdp	// check if neighbor is on fire
		rjumpc BARRIER_NXT // jump to BARRIER_NXT if neighbor is on fire
		pushn det


		pushc 1
		getvar 9
		getnbr
		rrdp  // check if neighbor has a detector
		pushcl BARRIER_NXT


		jumpc // jump to BARRIER_NXT if neighbor alrady has a detector
		getvar 9
		getnbr
		wclone // clone self on neighbor
		pushcl BARRIER_NXT2
		
		
		jumps // jump back to BARRIER_NXT2
CHECK_DIST	setvar 10  // heap[10] = location parameter
		pushc 1
		setvar 11 // heap[11] = heap address of current neighbor
		pushc 0 // counter
CHECK_DIST_LOOP	copy
		getvar 0
		ceq
		pushcl CHECK_DIST_DONE
		
		
		jumpc   // we've checked all neighbors
		getvar 11
		getvars
		getvar 10
		dist
		pushc 2
		cgt  // check if distance is > 2
		rjumpc CHECK_DIST_NXT
		pop // pop counter off stack
		pushc 1
		cpull     // The distance is <= 2, set cond = 1 and goto fin
		rjump CHECK_DIST_FIN
CHECK_DIST_NXT	getvar 11  // The dist is > 2, check next neighbor
		inc
		setvar 11 // heap[11]++
		inc  // counter++
		pushcl CHECK_DIST_LOOP		
		
		
		jumps 
CHECK_DIST_DONE	pop // pop counter off stack		
		pushc 0
		cpull // set condition = 0		
CHECK_DIST_FIN	pushc 10
		clearvar  // clear heap[10]
		pushc 11
		clearvar  // clear heap[11]
		jumps // return







// This procedure checks the distance of the location on the stack
// with all of the location on the heap, sets cond=1 if the location
// on the stack is <= 2 of any of the locations on the heap.  Assumes
// heap[0] = number of locations, heap[1...n] = location of each
// neighbor.
//
// Param:  [location], [return address]					



		

