REGISTER_RXN	pushn fir


		pushc 1
		pushcl DIE
		
		
		regrxn  // register fire reaction, die when reaction fires
CHECK_DETECTOR	pushn det


		pushc 1
		rdp  
		pushcl DIE2
		
		
		jumpc  // Die if detection tuple is already here.
OUT_DETECTOR	pushn det


		pushc 1
		out  // OUT a detector tuple				
Y_THREEBLINK  	pushc 0
Y_TBLOOP  	copy
        	pushc 6
        	cneq
        	rjumpc Y_TBCONT
        	pop     // clear the opstack
        	rjump CHECK_NEIGHBORS
Y_TBCONT  	pushc 28
        	putled        // toggle yellow LED        
        	pushc 1
        	sleep
        	inc
        	rjump Y_TBLOOP	        	
CHECK_NEIGHBORS	pushc RETURN1
		pushcl CHK_FIRE
		
		
		jumps // check if any neighbor has fire
RETURN1		rjumpc FIRE_FOUND // jump to FIRE_FOUND if >1 neighbor is on fire
		pushn det  // No neighbors are on fire, weak move to random neighbor
		
		
		pushc 1
		inp  // remove the detector tuple		
		randnbr
		wmove  // weak move to random neighbor
FIRE_FOUND	pushc 0  // A neighbor is on fire, clone self to all nodes that are not on fire and do not already have a fire detection tuple
		setvar 1  // heap[1] = 0, neighbor iterator
BARRIER_BEGIN	getvar 1
		numnbrs
		clt
		rjumpc BARRIER_CONT		
		pushc FIRE_FOUND
		rand  // done looking at each neighbor		
		pushc 15 // 15=1111b
		land     
		pushc 10
		add
		pushcl BLINKGREENC 
		
		
		jumps // blink the green LED 10-25 times				
BARRIER_CONT	pushn fir  // check if neighbor is on fire


		pushc 1
		getvar 1
		getnbr  
		rrdp	// check if neighbor is on fire
		pushcl BARRIER_NXT


		jumpc // jump to BARRIER_NXT if neighbor is on fire
		pushn det


		pushc 1
		getvar 1
		getnbr
		rrdp  // check if neighbor has a detector
		pushcl BARRIER_NXT


		jumpc // jump to BARRIER_NXT if neighbor has a detector already
		getvar 1  // neighbor does not have
		getnbr
		sclone // clone self on neighbor
		cpush
		pushc 2
		ceq
		rjumpc CLONE
		rjump BARRIER_NXT2 // parent agent skips to next agent
CLONE		pushcl RETURN2           // the clone must check whether a neighbor is on fire


		rjump CHK_FIRE
RETURN2		pushcl REGISTER_RXN


		jumpc  // jump to beginning if a neighbor is on fire
		halt  // halt if no neighbors are on fire		
BARRIER_NXT     pop  // the neighbor is on fire, skip to the next neighbor
		pop   // pop fire or detector tuple off stack
BARRIER_NXT2	getvar 1
		inc
		setvar 1 // heap[1]++
		pushc BARRIER_BEGIN
		jumps	
CHK_FIRE 	pushc 0  // Checks each neighbor to see if they are on fire. If at least one neighbor is on fire, set cond=1
		setvar 0  // heap[0] = 0, neighbor iterator
CHK_FIRE_BEGIN  getvar 0
		numnbrs
		clt
		rjumpc CHK_FIRE_CONT
		pushc 0
		clearvar  // clear heap[0]
		pushc 0
		cpull  // no neighbors on fire, set cond=0
		jumps // return
CHK_FIRE_CONT	pushn fir


		pushc 1
		getvar 0
		getnbr  
		rrdp	// check if ith neighbor is on fire
		rjumpc CHK_FIRE_FOUND
		getvar 0
		inc
		setvar 0 // heap[0]++
		pushcl CHK_FIRE_BEGIN
		
		
		jumps		
CHK_FIRE_FOUND  pop
		pop   // pop fire tuple off stack
		pushc 0
		clearvar  // clear heap[0]
		pushc 1
		cpull // fire found, set cond=1
		jumps // return
BLINKGREENC 	pushc 26 // Blinks the green LED a certain number of times. This procedure expects the stack to be [val=#blinks][return address]				
		putled // blink green
		pushc 1
		sleep
		dec
		copy
		pushc 0
		ceq
		rjumpc BLINKGREENCD
		rjump BLINKGREENC
BLINKGREENCD	pop
		jumps
DIE		pushc 9
		putled // turn off green LED
		pushn det
		pushc 1
		inp  // remove fire detector tuple
DIE2		halt		