	pushc 1
	pushn fda


	pushc 2
	out               // out a fire detect tuple
	pushc 2
	putled            // turn on green LED
BEGIN	pushc 1
	pushn flm


	pushc 2
	rdp
	pushcl EXIT


	jumpc             // jump to EXIT if there is a fire agent on local host
	clear             
	pushc 20      
	sleep             // sleep for 5 second
	pusht value  
	pushn hid


	pushc 2
	inp               // remove a host tuple from the local tuple space
	rjumpc DOHOST     // jump to DOHOST if a host tuple was found
	pushc 40
	sleep             // sleep for 10s
	pusht value  
	pushn hid


	pushc 2
	rrdpg             // get all host tuples within a 1 hop range
	pushc BEGIN
	jumps             // unconditionally jump to BEGIN
DOHOST	pop               // pop off the first field of host tuple (name)
	copy              // copy the address
	hid
	ceq               // check whether the address is local
	pushc BEGIN
	jumpc             // jump to BEGIN if the address is local
	setvar 2          // save address in heap[2]
	pushc 1
	pushn flm


	pushc 2
	getvar 2
	rrdp              // check whether there is a fire on the destination host
	pushc BEGIN
	jumpc             // jump to BEGIN if dest host has a fire agent
	clear
	pushc 1
	pushn fda


	pushc 2
	getvar 2
	rrdp              // check whether there is a FD agent on the destination host
	rjumpc SKIP       // jump if dest host has a fire detector agent
	clear        
	getvar 2          // get the destination host address
	clonew            // clone at destination host
SKIP	pushc BEGIN
	jumps             // unconditionally jump to BEGIN, pc = 7
EXIT	pushc 1           // remove fire detector tuple and die
	pushn fda  


	pushc 2
	inp
	halt              

/**
 * GENERAL PSEUDOCODE
 *
 *
 * out a FDA tuple
 * turn on green LED
 * while(true) {
 *   rdp for FIRE tuple
 *   if (FIRE tuple found)
 *     exit;
 *   else {
 *     sleep for 1 second
 *     inp HOST tuple
 *     if (HOST tuple found) {
 *       if (HOST tuple is local)
 *         break;
 *       else {
 *         rrdp on remote host for FIRE tuple
 *         if (FIRE tuple found)
 *           break;
 *         else {
 *           rrdp on remote host for FDA tuple
 *           if (FDA tuple found)
 *             break;
 *           else
 *             clone at remote host
 *         }
 *       }
 *     }
 *   }
 * }
 */	
