BEGIN		pushc RETURN1
		pushcl BLIPALL			
		jumps
		
RETURN1		pushc RETURN2
		pushcl CHECKFLAME					
		jumps

RETURN2		pushc FIREFOUND
		jumpc        
		
		pushc RETURN3
		pushcl RANDWEAKMOVE
		jumps
		
RETURN3		pushcl BLINKYELLOW
		jumps 			// blink yellow if error moving
							
FIREFOUND	pushn fdt
		pushc 1
		out              // insert a fire detector tuple		
FINDNBR		randnbr
		rjumpc FINDNBR1
		pushcl BLINKGREEN
		jumps              // if no neighbor, blink green (fire already found)
FINDNBR1	setvar 0
		pushn flm
		pushc 1
		getvar 0
		rrdp
		rjumpc FINDNBR // neighbor in flames, find another nbr
		pushn fdt
		pushc 1
		getvar 0
		rrdp
		pushc FINDNBR
		jumpc          // neighbor aready has fire detector
		getvar 0
		wclone
		pushcl BLINKGREEN
		jumps

//--------------------------------------------------------------------------		
CHECKFLAME	numnbrs	
CHECKNEXT     	copy
            	pushc 0	
            	cneq
            	rjumpc CHECKFLAME1
            	pop
            	pushc 0
            	clearvar  // clear heap
            	pushc 0
            	cpull			
            	jumps     // no more neighbors, set cond=0, return to callee
CHECKFLAME1    	pushc 1
            	inv
            	add		
            	copy	 	 // OS: [numnbrs-1] [numnbrs-1]	
            	getnbr
            	rjumpc CHECKFLAME2
            	pushcl CHECKNEXT            	            	
		jumps	               // neighbor did not exist, try again
CHECKFLAME2     setvar 0       
		pushn flm		
		pushc 1
		getvar 0
		rrdp
		rjumpc CHECKFLAME3		
		pushcl CHECKNEXT        // neighbor not in flames, try again			
		jumps
CHECKFLAME3	pop
		pop  // pop the flame tuple
		pop  // pop the next nbr count
		pushc 0
		clearvar  // clear the heap
		pushc 1
		cpull 
		jumps  // set cond=1, return to callee		

// Randomly walk around checking neighbors for flame.
// Once find a flame, clone self to all other neighbors.
// If a clone, check for a neighbor w/ a flame, if one
// exists, blink green, otherwise die.


//---------------------------------------------------------------------
RANDWEAKMOVE	randnbr
		rjumpc RWMGO
		jumps			
RWMGO		wmove  // move to a random neighbor (weak)	
		jumps
		
//---------------------------------------------------------------------		
BLIPALL		pushc 7
		putled
		pushc 8
		sleep
		pushc 0
		putled
		jumps

//---------------------------------------------------------------------
BLINKGREEN  	pushc 26
            	putled
            	pushc 8
            	sleep            
            	rjump BLINKGREEN
            	
//---------------------------------------------------------------------
BLINKYELLOW  	pushc 28
             	putled
             	pushc 8
             	sleep             
             	rjump BLINKYELLOW            	
             	
//---------------------------------------------------------------------             	
DIE		halt