/* "Copyright (c) 2000-2004 University of Virginia.  
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF VIRGINIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * VIRGINIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF VIRGINIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF VIRGINIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 */

/* Authors: Tian He*/
//$Id: Register.h,v 1.1.1.1 2004/07/13 21:42:34 th7c Exp $

#ifndef _REGISTER_H_
#define _REGISTER_H_


#define MAX_REGIESTER_NUM 10
#define MAX_PAYLOAD_SIZE MAX_REGIESTER_NUM * 2
#define QUERYCODE 168
#define REPLYCODE 186
#define BEEP_REQUEST 188 /* to faciliate the retrival of the motes */

typedef struct {	
uint8_t* pointers[MAX_REGIESTER_NUM]; //pointers to the first byte of the data 
uint8_t	dataSize[MAX_REGIESTER_NUM]; // the size of the data. zero size denotes this pointer is invalid
} registerInfo;

typedef struct {
uint8_t queryCommand;
uint8_t queryID;		
uint16_t senderId;
uint8_t PAYLOAD[MAX_PAYLOAD_SIZE];
}ReplyMsg;

typedef struct {
  uint8_t queryCommand;
  uint8_t queryID;
  uint16_t receiverId;		
} QueryConfig;

#endif
