// $Id: DelugeMetadata.h,v 1.1 2004/10/28 04:24:11 th7c Exp $

/*									tab:4
 *
 *
 * "Copyright (c) 2000-2004 The Regents of the University  of California.  
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */

/**
 * Manages Deluge metadata.
 *
 * @author Jonathan Hui <jwhui@cs.berkeley.edu>
 */

#ifndef __DELUGEIMGMETADATA_H__
#define __DELUGEIMGMETADATA_H__

#define DELUGE_METADATA_FLUSH_INTERVAL 4

typedef int16_t  imgvnum_t;
typedef uint8_t  pgnum_t;

typedef struct DelugeImgSummary {
  imgvnum_t vNum;                           // version num of image
  pgnum_t   numPgs;                         // num pages of complete image
  pgnum_t   numPgsComplete;                 // num pages available to send
} DelugeImgSummary;

typedef struct DelugeMetadata {
  uint16_t         crc;
  DelugeImgSummary imgSummary[DELUGE_NUM_IMGS];
} DelugeMetadata;

#endif
