// $Id: bl_functions.h,v 1.1 2004/10/28 04:24:20 th7c Exp $

/*									tab:4
 *
 *
 * "Copyright (c) 2000-2004 The Regents of the University  of California.  
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */

/**
 * bl_functions.h - For avr platform.
 *
 * @author Jonathan Hui <jwhui@cs.berkeley.edu>
 * @since  0.1
 */

#ifndef __BL_FUNCTIONS_H__
#define __BL_FUNCTIONS_H__

#include <avr/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <bl_flash.h>
#include <hardware.h>

#define runApp()				\
  __asm__ __volatile__ ("jmp 0x0000\n\t" ::)

#define EXTRA_INIT()				\
  ;

#define DISABLE_INTERRUPTS()			\
  cli()

#define DISABLE_WDT()				\
  wdt_disable()

#define ENABLE_WDT()				\
  wdt_enable(1)

#define delayFull()				\
  {						\
    int i;					\
    for ( i = 0; i < 8; i++ )			\
      TOSH_uwait(0x7fff);			\
  }

#define delayHalf()				\
  {						\
    int i;					\
    for ( i = 0; i < 4; i++ )			\
      TOSH_uwait(0x7fff);			\
  }

#endif
