/*
 * Copyright (c) 2004-2006, University of Virginia
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF VIRGINIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE VANDERBILT
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF VIRGINIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF VIRGINIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

// Authors: Brian Blum, Tian He, Liqian Luo

#ifndef __GROUPMANAGEMENT_H__
#define __GROUPMANAGEMENT_H__

#include "SystemParameters.h"
#include "structures.h"

typedef enum {
  STOP,
  NONE, 
  FOLLOWER,
  MEMBER,
  NEWCANDIDATE,
  LEADERCANDIDATE,
  LEADER,
  RESIGNINGLEADER,
} NodeStatus;

typedef enum {
  CANDIDATE,
  RECRUIT, 
  RESIGN,
} GMMsgType;

typedef struct {
  GMInfo GMInformation;
  Pair_uint16_t leaderLocation;
  uint16_t sequenceNum;
  state_t state;
  uint8_t TTL;
  NodeStatus status;
} GMStatus;

typedef struct {
  uint16_t groupID;
  uint16_t leaderID;
  Pair_uint16_t leaderLocation;
  uint16_t sequenceNum;
  uint16_t BL;
  state_t state;
  uint8_t TTL;
  uint8_t type;
} GMPacket;
#endif
