/* "Copyright (c) 2000-2004 University of Virginia.  
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF VIRGINIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * VIRGINIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF VIRGINIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF VIRGINIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 */

// Authors: Tian He
// $Id: MainControl.h,v 1.1.1.1 2004/07/13 21:42:33 th7c Exp $

#ifndef __MAINCONTROL_H__
#define __MAINCONTROL_H__

#include "configuration.h"

/* legitimate system phases/states */
enum {
  STATE_CHAOS, 
  STATE_INIT,
  STATE_SYSSYNC,
  STATE_LOCALIZE,                  
  STATE_DISCNEIGHBORS,
  STATE_BUILDBACKBONE,  
  STATE_COMMITBACKBONE,  
  STATE_SENTRYSEL,  //6
  STATE_STATUS_REPORT,
  STATE_SENSOR_CALIBRATION, //8 = 0
  STATE_TRACKNING_WITH_PM, //9 = 1
} NETWORK_STATES;

#ifdef PLATFORM_PC 

char state_name[12][50] = {
  "STATE_CHAOS", 
  "STATE_INIT",
  "STATE_SYSSYNC", 
  "STATE_LOCALIZE",
  "STATE_DISCNEIGHBORS",
  "STATE_BUILDBACKBONE",
  "STATE_COMMITBACKBONE",  
  "STATE_SENTRYSEL",
  "STATE_STATUS_REPORT",
  "STATE_PM",
  "STATE_TRACKNING_WITH_PM"
};
#endif

#endif // __MAINCONTROL_H__


