// $Id: AgillaOpcodes.java,v 1.2 2005/03/21 21:17:03 liang Exp $

/* Agilla - A middleware for wireless sensor networks.
 * Copyright (C) 2004, Washington University in Saint Louis
 * By Chien-Liang Fok.
 *
 * Washington University states that Agilla is free software;
 * you can redistribute it and/or modify it under the terms of
 * the current version of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * Agilla is distributed in the hope that it will be useful, but
 * THERE ARE NO WARRANTIES, WHETHER ORAL OR WRITTEN, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
 *
 * YOU UNDERSTAND THAT AGILLA IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. THERE ARE NO
 * WARRANTIES AND NO REPRESENTATION THAT AGILLA IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER
 * PROPRIETARY RIGHTS.  THERE ARE NO WARRANTIES THAT SOFTWARE IS
 * FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS",
 * OR OTHER HARMFUL CODE.
 *
 * YOU ASSUME THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
 * INFORMATION GENERATED USING SOFTWARE. By using Agilla you agree to
 * indemnify, defend, and hold harmless WU, its employees, officers and
 * agents from any and all claims, costs, or liabilities, including
 * attorneys fees and court costs at both the trial and appellate levels
 * for any loss, damage, or injury caused by your actions or actions of
 * your officers, servants, agents or third parties acting on behalf or
 * under authorization from you, as a result of using Agilla.
 *
 * See the GNU Lesser General Public License for more details, which can
 * be found here: http://www.gnu.org/copyleft/lesser.html
 */
/**
 * AgillaOpCodes.java
 *
 * @author Chien-Liang Fok
 */

package edu.wustl.mobilab.agilla_dsys25;

public interface AgillaOpcodes
{
	/* B-class instructions */

  // zero operand instructions
	public static final byte OPhalt      = 0x00;
	public static final byte OPloc       = 0x01;
	public static final byte OPaid       = 0x02;
	public static final byte OPrand      = 0x03;
	public static final byte OPcpush     = 0x04;
	public static final byte OPdepth     = 0x05;
	//public static final byte OPerr       = 0x06;
	public static final byte OPvicinity  = 0x06;
	public static final byte OPclear     = 0x07;
	public static final byte OPnumnbrs   = 0x08;
	public static final byte OPrandnbr   = 0x09;
	public static final byte OPwait      = 0x0a;

  // One operand instructions
	public static final byte OPinc       = 0x0b;
	public static final byte OPclearvar  = 0x0c;
	public static final byte OPinv       = 0x0d;
	public static final byte OPnot       = 0x0e;
	public static final byte OPlnot      = 0x0f;
	public static final byte OPcopy      = 0x10;
	public static final byte OPpop       = 0x11;
	public static final byte OPcpull     = 0x12;
	public static final byte OPsleep     = 0x13;
	public static final byte OPjumpc     = 0x14;
	public static final byte OPjumps     = 0x15;
	public static final byte OPputled    = 0x16;
	public static final byte OPsmove     = 0x17;
	public static final byte OPwmove     = 0x18;
	public static final byte OPsclone    = 0x19;
	public static final byte OPwclone    = 0x1a;
	public static final byte OPgetvars   = 0x1b;
	public static final byte OPsetvars   = 0x1c;
	public static final byte OPgetnbr    = 0x1d;
	public static final byte OPcisnbr    = 0x1e;
	public static final byte OPsense     = 0x1f;
	public static final byte OPdec       = 0x20;

  // Two and three operand-instructions
	public static final byte OPdist      = 0x21;
	public static final byte OPswap      = 0x22;
	public static final byte OPland      = 0x23;
	public static final byte OPlor       = 0x24;
	public static final byte OPand       = 0x25;
	public static final byte OPor        = 0x26;
	//public static final byte OPshiftr    = 0x27;
	//public static final byte OPshiftl    = 0x28;
	public static final byte OPmul       = 0x27;
	public static final byte OPdiv       = 0x28;
	public static final byte OPadd       = 0x29;
	public static final byte OPmod       = 0x2a;
	public static final byte OPceq       = 0x2b;
	public static final byte OPcneq      = 0x2c;
	public static final byte OPclt       = 0x2d;
	public static final byte OPcgt       = 0x2e;
	public static final byte OPclte      = 0x2f;
	public static final byte OPcgte      = 0x30;
	public static final byte OPceqtype   = 0x31;
	public static final byte OPcistype   = 0x32;

	public static final byte OPout       = 0x33;
	public static final byte OPinp       = 0x34;
	public static final byte OPrdp       = 0x35;
	public static final byte OPin        = 0x36;
	public static final byte OPrd        = 0x37;
	public static final byte OPtcount    = 0x38;

	public static final byte OProut      = 0x39;
	public static final byte OPrinp      = 0x3a;
	public static final byte OPrrdp      = 0x3b;
	//public static final byte OPrinpg     = 0x3c;
	public static final byte OPrrdpg     = 0x3d;
	public static final byte OPregrxn      = 0x3e;
	public static final byte OPderegrxn    = 0x3f;


/*  T class  Instruction format: 0100 ixxx*/
	public static final byte OPpushrt    = 0x40;
	public static final byte OPpusht     = 0x48;

/*   E-Class Instruction; format: 0101 ixxx yyyy yyyy yyyy yyyy]*/
	public static final byte OPpushn     = 0x50;
	public static final byte OPpushcl    = 0x51;
	public static final byte OPpushloc   = 0x52;

/*   V-Class Instruction; format:  011i xxxx */
	public static final byte OPgetvar    = 0x60;  // 5th bit must = 1
	public static final byte OPsetvar    = 0x70;  // 5th bit must = 0

/*   J class   Instruction format:  10ix xxxx */
	public static final short OPrjumpc    = 0x80;  // 100x xxxx conditional relative jump
	public static final short OPrjump     = 0xa0;  // 101x xxxx unconditional relative jump

/*   xclass   Instruction format:  11xx xxxx*/
	public static final short OPpushc     = 0xc0;   // push a constant onto op stack

//	public static final byte OPhalt      = 0x00;
//	public static final byte OPhid       = 0x01;
//	public static final byte OPaid       = 0x02;
//	public static final byte OPrand      = 0x03;
//	public static final byte OPctrue     = 0x04;
//	public static final byte OPcfalse    = 0x05;
//	public static final byte OPcpush     = 0x06;
//	public static final byte OPcistype   = 0x07;
//	public static final byte OPdepth     = 0x08;
//	public static final byte OPerr       = 0x09;
//	public static final byte OPflush     = 0x0a;
//	public static final byte OPclear     = 0x0b;
//
//	// One operand instructions
//	public static final byte OPinc       = 0x13;
//	public static final byte OPclearvar  = 0x14;
//	public static final byte OPinv       = 0x15;
//	public static final byte OPnot       = 0x16;
//	public static final byte OPlnot      = 0x17;
//	public static final byte OPstartsense= 0x18;
//	public static final byte OPstopsense = 0x19;
//	public static final byte OPcopy      = 0x1a;
//	public static final byte OPpop       = 0x1b;
//	public static final byte OPcpull     = 0x1c;
//	public static final byte OPsleep     = 0x1d;
//	public static final byte OPjumpc     = 0x1e;  // LSB must equal 0
//	public static final byte OPjumps     = 0x1f;  // LSB must equal 1
//	public static final byte OPputled    = 0x20;
//	public static final byte OPcast      = 0x21;
//	public static final byte OPmoves     = 0x22;
//	public static final byte OPmovew     = 0x23;
//	public static final byte OPclones    = 0x24;
//	public static final byte OPclonew    = 0x25;
//
//
//	// Two and three operand-instructions
//	public static final byte OProut      = 0x26;
//	public static final byte OPrinp      = 0x27;
//	public static final byte OPrrdp      = 0x28;
//	public static final byte OPrinpg     = 0x29;
//	public static final byte OPrrdpg     = 0x2a;
//	public static final byte OPout       = 0x2b;
//	public static final byte OPinp       = 0x2c;
//	public static final byte OPrdp       = 0x2d;
//	public static final byte OPin        = 0x2e;
//	public static final byte OPrd        = 0x2f;
//	public static final byte OPswap      = 0x30;
//	public static final byte OPland      = 0x31;
//	public static final byte OPlor       = 0x32;
//	public static final byte OPand       = 0x33;
//	public static final byte OPor        = 0x34;
//	public static final byte OPshiftr    = 0x35;
//	public static final byte OPshiftl    = 0x36;
//	public static final byte OPadd       = 0x37;
//	public static final byte OPmod       = 0x38;
//	public static final byte OPceq       = 0x39; // LSB = 1
//	public static final byte OPcneq      = 0x3a; // LSB = 0
//	public static final byte OPclt       = 0x3b;
//	public static final byte OPcgt       = 0x3c;
//	public static final byte OPclte      = 0x3d;
//	public static final byte OPcgte      = 0x3e;
//	public static final byte OPceqtype   = 0x3f;
//
//	/*  T class  Instruction format: 0100 ixxx*/
//	public static final byte OPpushrt    = 0x41;
//	public static final byte OPpusht     = 0x48;
//
//	/*   E-Class Instruction; format: 0101 ixxx yyyy yyyy yyyy yyyy]*/
//	public static final byte OPpushn     = 0x50;
//	public static final byte OPpushcl    = 0x51;
//
//	/*   V-Class Instruction; format:  011i xxxx */
//	public static final byte OPgetvar    = 0x60;  // 5th bit must = 1
//	public static final byte OPsetvar    = 0x70;  // 5th bit must = 0
//
//	/*   J class   Instruction format:  10ix xxxx */
//	public static final short OPrjumpc    = 0x80;  // 100x xxxx conditional relative jump
//	public static final short OPrjump     = 0xa0;  // 101x xxxx unconditional relative jump
//
//	/*   xclass   Instruction format:  11xx xxxx*/
//	public static final short OPpushc     = 0xc0;   // push a constant onto op stack
}

