// $Id: AgillaGridSizeMsgJ.java,v 1.1.2.1 2005/05/06 15:43:05 liang Exp $

/* Agilla - A middleware for wireless sensor networks.
 * Copyright (C) 2004, Washington University in Saint Louis
 * By Chien-Liang Fok.
 *
 * Washington University states that Agilla is free software;
 * you can redistribute it and/or modify it under the terms of
 * the current version of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * Agilla is distributed in the hope that it will be useful, but
 * THERE ARE NO WARRANTIES, WHETHER ORAL OR WRITTEN, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
 *
 * YOU UNDERSTAND THAT AGILLA IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. THERE ARE NO
 * WARRANTIES AND NO REPRESENTATION THAT AGILLA IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER
 * PROPRIETARY RIGHTS.  THERE ARE NO WARRANTIES THAT SOFTWARE IS
 * FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS",
 * OR OTHER HARMFUL CODE.
 *
 * YOU ASSUME THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
 * INFORMATION GENERATED USING SOFTWARE. By using Agilla you agree to
 * indemnify, defend, and hold harmless WU, its employees, officers and
 * agents from any and all claims, costs, or liabilities, including
 * attorneys fees and court costs at both the trial and appellate levels
 * for any loss, damage, or injury caused by your actions or actions of
 * your officers, servants, agents or third parties acting on behalf or
 * under authorization from you, as a result of using Agilla.
 *
 * See the GNU Lesser General Public License for more details, which can
 * be found here: http://www.gnu.org/copyleft/lesser.html
 */
package edu.wustl.mobilab.agilla_dsys25.messages;

import edu.wustl.mobilab.agilla_dsys25.*;
import edu.wustl.mobilab.agilla_dsys25.variables.*;
import net.tinyos.message.*;
import java.util.Vector;

public class AgillaGridSizeMsgJ implements MessageJ, AgillaConstants {
	private int numCol;
	
	private AgillaGridSizeMsgJ() {
	}
	
	public AgillaGridSizeMsgJ(int numCol) {
		this();
		this.numCol = numCol;
	}
	
	public AgillaGridSizeMsgJ(AgillaGridSizeMsg msg) {
		numCol = msg.get_numCol();
	}
	
	public int getType() {
		return AM_AGILLAGRIDSIZEMSG;
	}
		
	public Message toTOSMsg() {
		AgillaGridSizeMsg msg = new AgillaGridSizeMsg();
		msg.set_numCol(numCol);
		return msg;
	}
	
	/**
	 * Returns the number of bytes used in the data field.
	 */
//	public int size() {
//		return 4;
//	}
	
	/**
	 * Returns the address of a particular entry.
	 */
//	public short getAddr(short pos) {
//		HeapItem h = (HeapItem)data.get(pos);
//		return h.pos;
//	}
	
	/**
	 * Returns the data of a particular entry.
	 */
//	public AgillaStackVariable getData(short pos) {
//		HeapItem h = (HeapItem)data.get(pos);
//		return h.sv;
//	}
	
	public String toString() {
		String result = "GRID SIZE MESSAGE: " + numCol;
//		for (int i = 0; i < data.size(); i++) {
//			HeapItem hi = (HeapItem)data.get(i);
//			result += "\tvar" + i + ": addr=" + hi.pos + ", var=" + hi.sv + "\n";
//		}
		return result;
	}
	
//	private class HeapItem {
//		AgillaStackVariable sv;
//		short pos;
//
//		public HeapItem(AgillaStackVariable sv, short pos) {
//			this.sv = sv;
//			this.pos = pos;
//		}
//	}
}

