// $Id: RxnTester.java,v 1.1.2.1 2005/05/24 18:18:22 liang Exp $

/*									tab:4
 * "Copyright (c) 2000-2003 The Regents of the University  of California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Copyright (c) 2002-2003 Intel Corporation
 * All rights reserved.
 *
 * This file is distributed under the terms in the attached INTEL-LICENSE
 * file. If you do not find these files, copies can be found by writing to
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300, Berkeley, CA,
 * 94704.  Attention:  Intel License Inquiry.
 */


/**
 * File: RxnTester.java
 *
 * Description:
 * Registers a reaction on the local tuple space, prints any received tuples.
 *
 * @author Chien-Liang Fok
 */


package edu.wustl.mobilab.agilla.clients.rxn_tester;

import edu.wustl.mobilab.agilla.*;
import edu.wustl.mobilab.agilla.variables.*;

public class RxnTester implements AgillaConstants, ReactionListener {

	edu.wustl.mobilab.agilla.TupleSpace ts;
	
	public RxnTester(edu.wustl.mobilab.agilla.TupleSpace ts) {
		Tuple t = new Tuple();
		t.addField(new AgillaType(AGILLA_TYPE_VALUE));
		Reaction r = new Reaction(Reaction.ONCE_PER_TUPLE, t, this);
		ts.registerReaction(r);
		System.out.println("RxnTester: Registered reaction for " + r);
	}
	
	public void reactionFired(Tuple t) {
		System.out.println("Reaction fired: " + t);
	}
	
	public String toString() {
		return "Local Reaction Tester";
	}
}

