/*
 * Copyright (c) 2004,2005 Hewlett-Packard Company
 * All rights reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:

 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *     * Neither the name of the Hewlett-Packard Company nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Accel interface file
 *
 * Authors:  Andrew Christian
 *           July 2005
 */

#ifndef __ACCEL_H
#define __ACCEL_H

#include "MSP430ADC12.h"

enum {
  TOS_ADC_ACCEL_X_PORT = unique("ADCPort"),
  TOS_ADC_ACCEL_Y_PORT = unique("ADCPort"),

  TOSH_ACTUAL_ADC_ACCEL_X_PORT = ASSOCIATE_ADC_CHANNEL( INPUT_CHANNEL_A0, REFERENCE_AVcc_AVss, 0 ),
  TOSH_ACTUAL_ADC_ACCEL_Y_PORT = ASSOCIATE_ADC_CHANNEL( INPUT_CHANNEL_A1, REFERENCE_AVcc_AVss, 0 ),

  ACCEL_SAMPLES_PER_PACKET = 20
};

struct AccelData {
  uint32_t number;
  uint16_t samples[ACCEL_SAMPLES_PER_PACKET];
};

#endif
