/*
 * Copyright (c) 2000-2005 The Regents of the University  of California.  
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */

// TestTrioMsg.h
// @author Jaein Jeong

typedef struct TestTrioMsg {
  uint8_t cmd;
  uint8_t subcmd;
  uint8_t arg[8];
  //double voltage;
} TestTrioMsg;

enum {
  AM_TESTTRIOMSG = 65 
}; 

enum {
  SUBCMD_OFF    = 0,
  SUBCMD_ON     = 1,

  CMD_REDLED    = 0, 
  CMD_GREENLED  = 1,
  CMD_YELLOWLED = 2,

  CMD_SOUNDER   = 10,
  CMD_SOUNDER_READ = 11,
  REPLY_SOUNDER_READ = 12,

  //CMD_PROMETHEUS_GETVOLTAGE = 15,
  //REPLY_PROMETHEUS_GETVOLTAGE = 16,
  //CMD_PROMETHEUS_CHARGE = 17,

  //SUBCMD_PROMETHEUS_REFVOL = 0,
  //SUBCMD_PROMETHEUS_CAPVOL = 1,
  //SUBCMD_PROMETHEUS_BATTVOL = 2,

  //SUBCMD_PROMETHEUS_CHARGE_MANUAL = 0,
  //SUBCMD_PROMETHEUS_CHARGE_AUTO = 1,

  CMD_X1226         = 20,
  CMD_X1226_SET     = 21,
  CMD_X1226_READ    = 22,
  REPLY_X1226_READ  = 23,

  SUBCMD_X1226_STATUS = 0,
  SUBCMD_X1226_INT    = 1,
  SUBCMD_X1226_RTC    = 2,
  SUBCMD_X1226_ALM0   = 3,
  SUBCMD_X1226_ALM1   = 4,

  CMD_IOSWITCH1_INIT = 30,
  CMD_IOSWITCH1_SET  = 31,
  CMD_IOSWITCH1_CLR  = 32,
  CMD_IOSWITCH1_READ = 33,
  REPLY_IOSWITCH1_READ = 34,
  REPLY_IOSWITCH1_INTERRUPT = 35,

  CMD_IOSWITCH2_INIT = 40,
  CMD_IOSWITCH2_SET  = 41,
  CMD_IOSWITCH2_CLR  = 42,
  CMD_IOSWITCH2_READ = 43,
  REPLY_IOSWITCH2_READ = 44,
  REPLY_IOSWITCH2_INTERRUPT = 45,

  CMD_PWSWITCH_INIT  = 50,
  CMD_PWSWITCH_SET   = 51,
  CMD_PWSWITCH_READ  = 52,
  REPLY_PWSWITCH_READ  = 53,
  CMD_PWSWITCH_GETADC  = 54,
  REPLY_PWSWITCH_ADCREADY = 55,

  CMD_PIR               = 60,
  CMD_PIR_POT_ADJUST    = 61,
  CMD_PIR_POT_READ      = 62,
  REPLY_PIR_POT_READ    = 63,
  CMD_PIR_GETADC        = 64,
  REPLY_PIR_ADCREADY    = 65,

  SUBCMD_PIR_DETECT     = 0,
  SUBCMD_PIR_QUAD       = 1,

  CMD_MAG               = 70,
  CMD_MAG_POT_ADJUST    = 71,
  CMD_MAG_POT_READ      = 72,
  REPLY_MAG_POT_READ    = 73,
  CMD_MAG_GETADC        = 74,
  REPLY_MAG_ADCREADY    = 75,
  CMD_MAG_SETRESET      = 76,

  SUBCMD_MAG_GAINX      = 0,
  SUBCMD_MAG_GAINY      = 1, 
  SUBCMD_MAG_ADC0       = 2,
  SUBCMD_MAG_ADC1       = 3, 

  CMD_MIC               = 80,
  CMD_MIC_POT_ADJUST    = 81,
  CMD_MIC_POT_READ      = 82,
  REPLY_MIC_POT_READ    = 83,
  CMD_MIC_GETADC        = 84,
  REPLY_MIC_ADCREADY    = 85,

  SUBCMD_MIC_GAIN       = 0,
  SUBCMD_MIC_DETECT     = 1, 
  SUBCMD_MIC_LPF0       = 2,
  SUBCMD_MIC_LPF1       = 3, 
  SUBCMD_MIC_HPF0       = 4,
  SUBCMD_MIC_HPF1       = 5, 

  CMD_GRENADE           = 90,

  CMD_PROMETHEUS_GETVOLTAGE     = 100,
  REPLY_PROMETHEUS_GETVOLTAGE   = 101,
  CMD_PROMETHEUS_SET_STATUS     = 102,
  CMD_PROMETHEUS_GET_STATUS     = 103,
  REPLY_PROMETHEUS_GET_STATUS   = 104,

  SUBCMD_PROMETHEUS_REFVOL = 0,
  SUBCMD_PROMETHEUS_CAPVOL = 1,
  SUBCMD_PROMETHEUS_BATTVOL = 2,

  SUBCMD_PROMETHEUS_AUTOMATIC   = 0,
  SUBCMD_PROMETHEUS_POWERSOURCE = 1,
  SUBCMD_PROMETHEUS_CHARGING    = 2,
  SUBCMD_PROMETHEUS_ADCSOURCE   = 3,

  CMD_DEBUG_MSG         = 250,
  REPLY_DEBUG_MSG       = 251,
};



